Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.borg.ui.util
Class TableSorter

    java.lang.Object
      javax.swing.table.AbstractTableModel
          net.sf.borg.ui.util.TableSorter

All Implemented Interfaces:
  Serializable, TableModel

    public class TableSorter

extends AbstractTableModel

TableSorter is a decorator for TableModels; adding sorting functionality to a supplied TableModel. TableSorter does not store or copy the data in its TableModel; instead it maintains a map from the row indexes of the view to the row indexes of the model. As requests are made of the sorter (like getValueAt(row, col)) they are passed to the underlying model after the row numbers have been translated via the internal mapping array. This way, the TableSorter appears to hold another copy of the table with the rows in a different order.

TableSorter registers itself as a listener to the underlying model, just as the JTable itself would. Events recieved from the model are examined, sometimes manipulated (typically widened), and then passed on to the TableSorter's listeners (typically the JTable). If a change to the model has invalidated the order of TableSorter's rows, a note of this is made and the sorter will resort the rows the next time a value is requested.

When the tableHeader property is set, either by using the setTableHeader() method or the two argument constructor, the table header may be used as a complete UI for TableSorter. The default renderer of the tableHeader is decorated with a renderer that indicates the sorting status of each column. In addition, a mouse listener is installed with the following behavior:

- Mouse-click: Clears the sorting status of all other columns and advances the sorting status of that column through three values: {NOT_SORTED, ASCENDING, DESCENDING} (then back to NOT_SORTED again).
- SHIFT-mouse-click: Clears the sorting status of all other columns and cycles the sorting status of the column through the same three values, in the opposite order: {NOT_SORTED, DESCENDING, ASCENDING}.
- CONTROL-mouse-click and CONTROL-SHIFT-mouse-click: as above except that the changes to the column do not cancel the statuses of columns that are already sorting - giving a way to initiate a compound sort.

This is a long overdue rewrite of a class of the same name that first appeared in the swing table demos in 1997.

Version:
  2.0 02/27/04
Author:
  Philip Milne, Brendon McLean, Dan van Enckevort, Parwinder Sekhon
See Also:
  Serialized Form

Field Summary
`static int` | `ASCENDING`
`static Comparator<Object>` | `COMPARABLE_COMAPRATOR`
`static int` | `DESCENDING`
`static Comparator<Object>` | `LEXICAL_COMPARATOR`
`static int` | `NOT_SORTED`
`protected TableModel` | `tableModel`

Fields inherited from class javax.swing.table.AbstractTableModel
`listenerList`

Constructor Summary
`TableSorter()`
`TableSorter(String[] cols, Class[] classes)`
`TableSorter(String[] cols, Class[] classes, boolean[] editable)`

Method Summary
`void` | `addMouseListenerToHeaderInTable(JTable table1)`
`void` | `addRow(Object[] ro)`
`Class` | `getColumnClass(int column)`
`int` | `getColumnCount()`
`String` | `getColumnName(int column)`
`protected Comparator<Object>` | `getComparator(int column)`
`protected Icon` | `getHeaderRendererIcon(int column, int size)`
`int` | `getMappedIndex(int index)`
`int` | `getRowCount()`
`int` | `getSortingStatus(int column)`
`JTableHeader` | `getTableHeader()`
`TableModel` | `getTableModel()`
`Object` | `getValueAt(int row, int column)`
`boolean` | `isCellEditable(int row, int column)`
`boolean` | `isSorted()`
`boolean` | `isSorting()`
`int` | `modelIndex(int viewIndex)`
`void` | `removeRow(int row)`
`void` | `setRowCount(int i)`
`void` | `setSortingStatus(int column, int status)`
`void` | `setTableHeader(JTableHeader tableHeader)`
`void` | `setTableModel(TableModel tableModel)`
`void` | `setValueAt(Object aValue, int row, int column)`
`void` | `sort()`
`void` | `sortByColumn(int i)`
`void` | `tableChanged(TableModelEvent event)`

Methods inherited from class javax.swing.table.AbstractTableModel
`addTableModelListener, findColumn, fireTableCellUpdated, fireTableChanged, fireTableDataChanged, fireTableRowsDeleted, fireTableRowsInserted, fireTableRowsUpdated, fireTableStructureChanged, getListeners, getTableModelListeners, removeTableModelListener`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### tableModel

    protected TableModel tableModel

### DESCENDING

    public static final int DESCENDING

See Also:
  Constant Field Values

### NOT_SORTED

    public static final int NOT_SORTED

See Also:
  Constant Field Values

### ASCENDING

    public static final int ASCENDING

See Also:
  Constant Field Values

### COMPARABLE_COMAPRATOR

    public static final Comparator<Object> COMPARABLE_COMAPRATOR

### LEXICAL_COMPARATOR

    public static final Comparator<Object> LEXICAL_COMPARATOR

Constructor Detail

### TableSorter

    public TableSorter()

### TableSorter

    public TableSorter(String[] cols,
                       Class[] classes,
                       boolean[] editable)

### TableSorter

    public TableSorter(String[] cols,
                       Class[] classes)

Method Detail

### getTableModel

    public TableModel getTableModel()

### setTableModel

    public void setTableModel(TableModel tableModel)

### getTableHeader

    public JTableHeader getTableHeader()

### setTableHeader

    public void setTableHeader(JTableHeader tableHeader)

### isSorting

    public boolean isSorting()

### getSortingStatus

    public int getSortingStatus(int column)

### setSortingStatus

    public void setSortingStatus(int column,
                                 int status)

### getHeaderRendererIcon

    protected Icon getHeaderRendererIcon(int column,
                                         int size)

### getComparator

    protected Comparator<Object> getComparator(int column)

### modelIndex

    public int modelIndex(int viewIndex)

### getRowCount

    public int getRowCount()

### getColumnCount

    public int getColumnCount()

### getColumnName

    public String getColumnName(int column)

  Specified by:
    `getColumnName` in interface `TableModel`
  Overrides:
    `getColumnName` in class `AbstractTableModel`

### getColumnClass

    public Class getColumnClass(int column)

  Specified by:
    `getColumnClass` in interface `TableModel`
  Overrides:
    `getColumnClass` in class `AbstractTableModel`

### isCellEditable

    public boolean isCellEditable(int row,
                                  int column)

  Specified by:
    `isCellEditable` in interface `TableModel`
  Overrides:
    `isCellEditable` in class `AbstractTableModel`

### getValueAt

    public Object getValueAt(int row,
                             int column)

### setValueAt

    public void setValueAt(Object aValue,
                           int row,
                           int column)

  Specified by:
    `setValueAt` in interface `TableModel`
  Overrides:
    `setValueAt` in class `AbstractTableModel`

### addMouseListenerToHeaderInTable

    public void addMouseListenerToHeaderInTable(JTable table1)

  Parameters:
    `table1` -

### addRow

    public void addRow(Object[] ro)

  Parameters:
    `ro` -

### removeRow

    public void removeRow(int row)

### tableChanged

    public void tableChanged(TableModelEvent event)

  Parameters:
    `event` -

### setRowCount

    public void setRowCount(int i)

  Parameters:
    `i` -

### sortByColumn

    public void sortByColumn(int i)

  Parameters:
    `i` -

### getMappedIndex

    public int getMappedIndex(int index)

### isSorted

    public boolean isSorted()

### sort

    public void sort()

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Generated September 24 2010 by mbb using Apache Ant version 1.7.1 compiled on June 27 2008 and Java version 1.6.0_20 from Sun Microsystems Inc. on Linux i386 2.6.24-28-generic